# Class GatewayTransfer<N>

#### Type Parameters

- #### N extends Network = Network

#### Hierarchy

- GatewayTransfer

#### Implements

- WormholeTransfer<"IbcBridge">

- Defined in connect/src/protocols/gatewayTransfer.ts:43

#####
Index

### Constructors

constructor

### Properties

_state
gateway
gatewayAddress
gatewayIbcBridge
ibcTransfers
msg
transactions
transfer
vaas?
wh
chain

### Methods

_transfer
_transferIbc
completeTransfer
fetchAttestation
fromGateway
getTransferState
initiateTransfer
toGateway
_fromMsgId
_fromTransaction
from
getTransferVaa
ibcTransfertoGatewayTransfer

## Constructors

### `Private` constructor

- new GatewayTransfer<N>(wh, transfer, gateway, gatewayIbc): GatewayTransfer<N>

- #### Type Parameters

  - #### N extends "Mainnet" | "Testnet" | "Devnet" = "Mainnet" | "Testnet" | "Devnet"

  #### Parameters

  - ##### wh: Wormhole<N>

  - ##### transfer: GatewayTransferDetails

  - ##### gateway: GatewayContext<N>

  - ##### gatewayIbc: IbcBridge<N, "Cosmwasm", "Terra" | "Terra2" | "Injective" | "Osmosis" | "Xpla" | "Sei" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira">

  #### Returns GatewayTransfer<N>

  - Defined in connect/src/protocols/gatewayTransfer.ts:79

## Properties

### `Private` _state

_state: TransferState

- Defined in connect/src/protocols/gatewayTransfer.ts:56

### `Private` `Readonly` gateway

gateway: GatewayContext<N>

- Defined in connect/src/protocols/gatewayTransfer.ts:49

### `Private` `Readonly` gatewayAddress

gatewayAddress: ChainAddress

- Defined in connect/src/protocols/gatewayTransfer.ts:53

### `Private` `Readonly` gatewayIbcBridge

gatewayIbcBridge: IbcBridge<N, "Cosmwasm", "Terra" | "Terra2" | "Injective" | "Osmosis" | "Xpla" | "Sei" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira">

- Defined in connect/src/protocols/gatewayTransfer.ts:51

### ibcTransfers

ibcTransfers: IbcTransferInfo[] = []

- Defined in connect/src/protocols/gatewayTransfer.ts:77

### `Private` msg

msg: GatewayTransferMsg | GatewayTransferWithPayloadMsg

- Defined in connect/src/protocols/gatewayTransfer.ts:61

### transactions

transactions: TransactionId[] = []

- Defined in connect/src/protocols/gatewayTransfer.ts:67

### transfer

transfer: GatewayTransferDetails

Implementation of WormholeTransfer.transfer

- Defined in connect/src/protocols/gatewayTransfer.ts:64

### `Optional` vaas

vaas?: {
id: WormholeMessageId;
vaa?: VAA<"TokenBridge:Transfer"> | VAA<"TokenBridge:TransferWithPayload">;
}[]

#### Type declaration

- ##### id: WormholeMessageId

- ##### `Optional` vaa?: VAA<"TokenBridge:Transfer"> | VAA<"TokenBridge:TransferWithPayload">

- Defined in connect/src/protocols/gatewayTransfer.ts:71

### `Private` `Readonly` wh

wh: Wormhole<N>

- Defined in connect/src/protocols/gatewayTransfer.ts:46

### `Static` chain

chain: "Wormchain" = "Wormchain"

- Defined in connect/src/protocols/gatewayTransfer.ts:44

## Methods

### `Private` _transfer

- _transfer(signer): Promise<TransactionId[]>

- #### Parameters

  - ##### signer: Signer

  #### Returns Promise<TransactionId[]>

  - Defined in connect/src/protocols/gatewayTransfer.ts:313

### `Private` _transferIbc

- _transferIbc(signer): Promise<TransactionId[]>

- #### Parameters

  - ##### signer: Signer

  #### Returns Promise<TransactionId[]>

  - Defined in connect/src/protocols/gatewayTransfer.ts:331

### completeTransfer

- completeTransfer(signer): Promise<string[]>

- #### Parameters

  - ##### signer: Signer

  #### Returns Promise<string[]>

  Implementation of WormholeTransfer.completeTransfer

  - Defined in connect/src/protocols/gatewayTransfer.ts:485

### fetchAttestation

- fetchAttestation(timeout?): Promise<AttestationId[]>

- #### Parameters

  - ##### `Optional` timeout: number

  #### Returns Promise<AttestationId[]>

  Implementation of WormholeTransfer.fetchAttestation

  - Defined in connect/src/protocols/gatewayTransfer.ts:350

### `Private` fromGateway

- fromGateway(): boolean

- #### Returns boolean

  - Defined in connect/src/protocols/gatewayTransfer.ts:534

### getTransferState

- getTransferState(): TransferState

- #### Returns TransferState

  Implementation of WormholeTransfer.getTransferState

  - Defined in connect/src/protocols/gatewayTransfer.ts:107

### initiateTransfer

- initiateTransfer(signer): Promise<string[]>

- #### Parameters

  - ##### signer: Signer

  #### Returns Promise<string[]>

  Implementation of WormholeTransfer.initiateTransfer

  - Defined in connect/src/protocols/gatewayTransfer.ts:294

### `Private` toGateway

- toGateway(): boolean

- #### Returns boolean

  - Defined in connect/src/protocols/gatewayTransfer.ts:537

### `Private` `Static` _fromMsgId

- _fromMsgId<N>(wh, from, timeout?): Promise<GatewayTransferDetails>

- #### Type Parameters

  - #### N extends "Mainnet" | "Testnet" | "Devnet"

  #### Parameters

  - ##### wh: Wormhole<N>

  - ##### from: WormholeMessageId

  - ##### `Optional` timeout: number

  #### Returns Promise<GatewayTransferDetails>

  - Defined in connect/src/protocols/gatewayTransfer.ts:168

### `Private` `Static` _fromTransaction

- _fromTransaction<N>(wh, from, timeout?): Promise<GatewayTransferDetails>

- #### Type Parameters

  - #### N extends "Mainnet" | "Testnet" | "Devnet"

  #### Parameters

  - ##### wh: Wormhole<N>

  - ##### from: TransactionId

  - ##### `Optional` timeout: number

  #### Returns Promise<GatewayTransferDetails>

  - Defined in connect/src/protocols/gatewayTransfer.ts:227

### `Static` from

- from<N>(wh, from): Promise<GatewayTransfer<N>>

- #### Type Parameters

  - #### N extends "Mainnet" | "Testnet" | "Devnet"

  #### Parameters

  - ##### wh: Wormhole<N>

  - ##### from: GatewayTransferDetails

  #### Returns Promise<GatewayTransfer<N>>

  - Defined in connect/src/protocols/gatewayTransfer.ts:112
- from<N>(wh, from, timeout?): Promise<GatewayTransfer<N>>

- #### Type Parameters

  - #### N extends "Mainnet" | "Testnet" | "Devnet"

  #### Parameters

  - ##### wh: Wormhole<N>

  - ##### from: WormholeMessageId

  - ##### `Optional` timeout: number

  #### Returns Promise<GatewayTransfer<N>>

  - Defined in connect/src/protocols/gatewayTransfer.ts:116
- from<N>(wh, from, timeout?): Promise<GatewayTransfer<N>>

- #### Type Parameters

  - #### N extends "Mainnet" | "Testnet" | "Devnet"

  #### Parameters

  - ##### wh: Wormhole<N>

  - ##### from: TransactionId

  - ##### `Optional` timeout: number

  #### Returns Promise<GatewayTransfer<N>>

  - Defined in connect/src/protocols/gatewayTransfer.ts:121

### `Static` getTransferVaa

- getTransferVaa<N>(wh, whm, timeout?): Promise<VAA<"TokenBridge:Transfer"> | VAA<"TokenBridge:TransferWithPayload">>

- #### Type Parameters

  - #### N extends "Mainnet" | "Testnet" | "Devnet"

  #### Parameters

  - ##### wh: Wormhole<N>

  - ##### whm: WormholeMessageId

  - ##### `Optional` timeout: number

  #### Returns Promise<VAA<"TokenBridge:Transfer"> | VAA<"TokenBridge:TransferWithPayload">>

  - Defined in connect/src/protocols/gatewayTransfer.ts:521

### `Private` `Static` ibcTransfertoGatewayTransfer

- ibcTransfertoGatewayTransfer(xfer): GatewayTransferDetails

- #### Parameters

  - ##### xfer: IbcTransferInfo

  #### Returns GatewayTransferDetails

  - Defined in connect/src/protocols/gatewayTransfer.ts:252

Generated using TypeDoc